addHook("PlayerSpin", function(p, inflictor, source)
	if not (p.mo and p.mo.valid) then return end
	if not (inflictor and inflictor.valid and inflictor.player and (inflictor.player.masteremerald and inflictor.player.masteremerald.super)) then return end
	
	if inflictor.skin == "achii" then
		if K_IsPlayerLosing(p) then return end
		
		if p.kartstuff[k_position] <= 3 then
			local spb = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SPBEXPLOSION)
			spb.target = inflictor
			if p.kartstuff[k_position] == 1 then
				spb.extravalue1 = 1
			end
			
			if ringsOn then
				inflictor.player.ringstuff.numRings = (spb.extravalue1) and 1 or $ - 5
			else
				inflictor.player.masteremerald.sparkle = (spb.extravalue1) and 7 or $ - (2*TICRATE)
			end
		end
	end
end)

local function AchiiSP(mo)
	if not (mo and mo.valid and mo.player) then return end
	if mo.skin ~= "achii" then return end
	local p = mo.player

	if (not p.masteremerald) and (not p.hugequest) then return end
	
	mo.lastsuper = $ or 0
	
	if (p.masteremerald and p.masteremerald.sparkle and p.masteremerald.super)then
		if not mo.lastsuper then
			S_StartSound(nil, sfx_kc57)
		end
		
		if not S_SoundPlaying(mo, sfx_kc57)
		and not S_SoundPlaying(mo, sfx_kc64) then
			S_StartSound(mo, sfx_kc64)
		end
	end
	
	if not p.masteremerald.sparkle and mo.lastsuper then
		if S_SoundPlaying(mo, sfx_kc64) then
			S_StopSoundByID(mo, sfx_kc64)
		end
	end
	
	if p.masteremerald.super
	and ringsOn then
		if leveltime%12 == 0 then
			local spbring = P_SpawnMobj(mo.x, mo.y, mo.z, MT_RINGSOMAP)
			if CV_FindVar("spbringextrareward").value then
				spbring.colorized = true
				spbring.color = SKINCOLOR_RED
			end
			spbring.justTouched = p
			spbring.extraamt = CV_FindVar("spbringextrareward").value
            spbring.scale = 3*mapobjectscale/2
			spbring.fuse = 20*TICRATE
            spbring.flags = $|MF_NOCLIPHEIGHT
		end
	end
	
	mo.lastsuper = p.masteremerald.super
end
addHook("MobjThinker", AchiiSP, MT_PLAYER)